package org.processmining.models.graphbased.directed.fuzzymodel.impl;

import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.AttributeMap.ArrowType;
import org.processmining.models.graphbased.directed.fuzzymodel.FMEdge;
import org.processmining.models.graphbased.directed.fuzzymodel.FMNode;

public class FMEdgeImpl extends FMEdge<FMNode, FMNode> {
	public FMEdgeImpl(FMNode source, FMNode target, double significance, double correlation) {

		super(source, target, significance, correlation);
		getAttributeMap().put(AttributeMap.EDGEEND, ArrowType.ARROWTYPE_TECHNICAL);
		getAttributeMap().put(AttributeMap.EDGEENDFILLED, true);
	}

	public String toString() {
//		String sourceLabel = source.getElementName() + "(" + source.getEventType() + ")";
//		String targetLabel = target.getElementName() + "(" + target.getEventType() + ")";
//		String edgeLabel = sourceLabel + "-->" + targetLabel;
		
		/* 
		 * HV: When any text here is returned, double-clicking an edge will throw a null-pointer exception.
		 * This exception is caused by the lack of font metrics to decide whether or not this text could
		 * have been selected by the double-click. By returning an empty string here, we prevent the 
		 * exception.
		 * 
		 *  Of course, this is not the proper way to do this, but at the moment I see no other way.
		 *  The only method that can set the metrics, is getLabelSize, but for that we need an EdgeRenderer an 
		 *  an EdgeView.
		 */
		return "";
	}
}
